﻿Type=StaticCode
Version=1.2
ModulesStructureVersion=1
B4R=true
@EndOfDesignText@


Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'Public variables can be accessed from all modules.
	Public Last As Byte
	Private lPin, cPin, dPin As Pin 
	Private clockPin, dataPin, Value As Byte 'ignore
	Private bitOrder As Boolean  ' ignore

End Sub

'Initialize by definition of the pins that connect to the shift register:
'latch_pin is connected to SR pin 12
'clock_pin is connected to SR pin 11
'data_pin is connected to SR pin 14
public Sub Initialize(latch_pin As Byte,clock_pin As Byte , data_pin As Byte,  bit_order As Boolean )
	clockPin = clock_pin
	dataPin  = data_pin
	bitOrder = bit_order
	lPin.Initialize(latch_pin,lPin.MODE_OUTPUT)
	cPin.Initialize(clock_pin,cPin.MODE_OUTPUT)
	dPin.Initialize(data_pin, dPin.MODE_OUTPUT)
End Sub

private Sub Write(byteValue As Byte)
	Value = byteValue
	lPin.DigitalWrite(False)
	RunNative("ShiftOut", Null)
	lPin.DigitalWrite(True)
End Sub

'Writes the byteValue to the shift register and to the output pins. 
public Sub SetAll(byteValue As Byte) 
	Write(byteValue)
End Sub

public Sub SetAllHigh As Byte
	Write(0xFF)
	Return 0xFF
End Sub

'sets bit n in bytevalue to 1
public Sub SetBit(byteValue As Byte, n As Byte) As Byte
	Dim val As Byte = Bit.Set(byteValue, n)
	Write(val)
	Return val
End Sub

Public Sub ClearAll As Byte
	Write(0x00)
	Return 0x00
End Sub

'sets bit n in bytevalue to 0
public Sub ClearBit(byteValue As Byte, n As Byte) As Byte
	Dim val As Byte = Bit.clear(byteValue, n)
	Write(val)
	Return val
End Sub



#If C
void ShiftOut(B4R::Object* o) {
shiftOut(b4r_shiftreg::_datapin, b4r_shiftreg::_clockpin,b4r_shiftreg::_bitorder, b4r_shiftreg::_value);
}
#End If